{----------------------------------------------------------------}
{ PNGFORM - Sub0 - Developpez.com - 15/06/06                     }
{----------------------------------------------------------------}
{$X+}
Unit Unit1;
Interface
Uses Windows, Messages, SysUtils, Classes, Graphics, Controls,
     Forms, Dialogs, ExtCtrls, StdCtrls, Math, HSLUtils;

Type
  TForm1 = Class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Image1: TImage;
    Image2: TImage;
    Procedure FormCreate(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure FusionForms;
  End;

Type
  TAlpha = Class(TForm)
    Procedure FormCreate(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure FormMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  End;


Var
  Form1: TForm1;
  AlphaForm: TAlpha;


{----------------------------------------------------------------}
{                                                                }
{                       }IMPLEMENTATION{                         }
{                                                                }
{----------------------------------------------------------------}
{$R *.DFM}
{$R Alpha.DFM}

Var FinalBitmap: TBitmap;


{----------------------------------------------------------------}
{ Function pour obtenir l'image 32bits  la place d'une form     }
{----------------------------------------------------------------}
Function UpdateLayeredWindow(hwnd: HWND; hdcDst: HDC; pptDst: PPoint;
  psize: PSize; hdcSrc: HDC; pptSrc: PPoint; crKey: TColor;
  pblend: PBlendFunction; dwFlags: DWORD): BOOL; stdcall; external 'user32.dll';


{----------------------------------------------------------------}
{ Procdure appellant la fonction UpdateLayeredWindow            }
{----------------------------------------------------------------}
Procedure FusionForm(Form: TForm; Bmp: TBitmap);
Const WS_EX_LAYERED = $80000;
Var Size: PSIZE;
    TopLeft, BmpTopLeft: TPoint;
    Blend: TBlendFunction;
Begin
  With Form Do Begin
    SetWindowLong(Handle, GWL_EXSTYLE,
      GetWindowLong(Handle, GWL_EXSTYLE) Or WS_EX_LAYERED);
    New(Size);
    Size.cx := Width;
    Size.cy := Height;
    TopLeft := BoundsRect.TopLeft;
    BmpTopLeft := Point(0, 0);
    With Blend Do Begin
      BlendOp := 0;
      BlendFlags := 0;
      SourceConstantAlpha := $FF;
      AlphaFormat := 1;
    End;
    Bmp.PixelFormat := pf32bit;
    UpdateLayeredWindow(Handle, GetDC(0), @TopLeft, Size,
      Bmp.Canvas.handle, @BmpTopLeft, 0, @Blend, 2);
  End;
End;


{----------------------------------------------------------------}
Procedure TForm1.FusionForms;
Var TmpBitmap, FusBitmap: TBitmap;
    pd, pa: pByteArray;
    tcol: TRGB;
    X, Y: Integer;
Begin
  // Emplacements transparents des controls sur l'image //
  TmpBitmap := TBitmap.Create;
  TmpBitmap.Width := Form1.Width;
  TmpBitmap.Height := Form1.Height;
  TmpBitmap.PixelFormat := pf24bit;
  Form1.BringToFront;
  TmpBitmap.Canvas.CopyRect(TmpBitmap.Canvas.ClipRect,
    Form1.Canvas, Form1.Canvas.ClipRect);
  FusBitmap := TBitmap.Create;
  FusBitmap.Assign(FinalBitmap);
  FusBitmap.PixelFormat := pf32bit;
  tcol := GetRGB(Form1.TransparentColorValue);
  For Y := 0 To FusBitmap.Height - 1 Do Begin
    pd := FusBitmap.ScanLine[Y];
    pa := TmpBitmap.ScanLine[Y];
    For X := 0 To FusBitmap.Width - 1 Do Begin
      If (pa[X * 3 + 2] <> tcol.R) Or
         (pa[X * 3 + 1] <> tcol.G) Or
         (pa[X * 3 + 0] <> tcol.B) Then Begin
        pd[X * 4 + 0] := 0;
        pd[X * 4 + 1] := 0;
        pd[X * 4 + 2] := 0;
        pd[X * 4 + 3] := 0;
      End;
    End;
  End;
  TmpBitmap := Nil;
  // Applique la nouvelle image  la form //
  FusionForm(AlphaForm, FusBitmap);
  FusBitmap := Nil;
  AlphaForm.Show;
  AlphaForm.BringToFront;
End;


{----------------------------------------------------------------}
{ Dessin d'un TBitmap 32bits sur un autre (fusion)               }
{----------------------------------------------------------------}
Procedure MyDrawPNG(X, Y: Integer; AlphaBitmap, FinalBitmap: TBitmap);
Var pd, pa: pByteArray;
    i, ix, j, a, b, ad: Integer;
Begin
  If (Assigned(AlphaBitmap) = False) Then Exit;
  If (Assigned(FinalBitmap) = False) Then Exit;
  FinalBitmap.PixelFormat := pf32bit;
  For j := 0 To AlphaBitmap.Height - 1 Do
    If (j + Y <= FinalBitmap.Height - 1) And (j + Y >= 0) Then Begin
      pd := FinalBitmap.ScanLine[j + Y];
      pa := AlphaBitmap.ScanLine[j];
      For i := 0 To AlphaBitmap.Width - 1 Do Begin
        a := pa[i * 4 + 3];
        b := Abs($FF - a);
        ix := Max(Min(i + X, FinalBitmap.Width - 1), 0);
        ad := pd[ix * 4 + 3];
        If (a >= 240) Then Begin
          pd[ix * 4 + 0] := pa[i * 4 + 0];
          pd[ix * 4 + 1] := pa[i * 4 + 1];
          pd[ix * 4 + 2] := pa[i * 4 + 2];
          pd[ix * 4 + 3] := $FF;
        End Else If (a >= 0) Then Begin
          If (ad < 240) Then
            b := Round(Max(Min(a + (ad * b) / 240, 240), 0));;
          pd[ix * 4 + 0] := Round(Max(Min(
            pa[i * 4 + 0] + b * pd[ix * 4 + 0] / $FF, $FF), 0));
          pd[ix * 4 + 1] := Round(Max(Min(
            pa[i * 4 + 1] + b * pd[ix * 4 + 1] / $FF, $FF), 0));
          pd[ix * 4 + 2] := Round(Max(Min(
            pa[i * 4 + 2] + b * pd[ix * 4 + 2] / $FF, $FF), 0));
          If (ad < 240) Then pd[ix * 4 + 3] := b;
        End;
      End;
    End;
End;


{----------------------------------------------------------------}
{ Cration & initialisation des forms                            }
{----------------------------------------------------------------}
Procedure TForm1.FormCreate(Sender: TObject);
Var AlphaBitmap: TBitmap;
Begin
  DoubleBuffered := True;
  Color := clFuchsia;
  TransparentColorValue := Color;
  BorderStyle := bsNone;

  // Chargement de l'image PNG pour l'arrire-plan //
  FinalBitmap := TBitmap.Create;
  FinalBitmap.Assign(Image1.Picture.Graphic);
  Width := FinalBitmap.Width;
  Height := FinalBitmap.Height;

  // Exemple d'ajot d'image PNG sur l'arrire-plan //
  AlphaBitmap := TBitmap.Create;
  AlphaBitmap.Assign(Image2.Picture.Graphic);
  MyDrawPNG(Image2.Left, Image2.Top, AlphaBitmap, FinalBitmap);
  AlphaBitmap := Nil;

  // Cration de la form d'arrire-plan //
  Application.CreateForm(TAlpha, AlphaForm);
End;

{----------------------------------------------------------------}
Procedure TAlpha.FormCreate(Sender: TObject);
Begin
  Left := Form1.Left;
  Top := Form1.Top;
  Width := Form1.Width;
  Height := Form1.Height;
  DoubleBuffered := True;
  BorderIcons := [];
  BorderStyle := bsNone;

  // Fusion de l'image finale sur la form & Affichage //
  Form1.Show;
  Application.ProcessMessages;
  Form1.FusionForms;
  AlphaForm.Show;
End;


{----------------------------------------------------------------}
{ Finalisation du programme                                      }
{----------------------------------------------------------------}
Procedure TAlpha.FormDestroy(Sender: TObject);
Begin
  FinalBitmap := Nil;
End;


{----------------------------------------------------------------}
{ Dplacement de la fentre (image et controls fusionns)        }
{----------------------------------------------------------------}
Procedure TAlpha.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var TmpBitmap, FusBitmap: TBitmap;
    pd, pa: pByteArray;
    tcol: TRGB;
Begin
  If (Button <> mbLeft) Then Exit;

  // Fusionne les controls et l'arrire-plan //
  TmpBitmap := TBitmap.Create;
  TmpBitmap.Width := Form1.Width;
  TmpBitmap.Height := Form1.Height;
  TmpBitmap.PixelFormat := pf24bit;
  AlphaForm.BringToFront;
  TmpBitmap.Canvas.CopyRect(TmpBitmap.Canvas.ClipRect, Form1.Canvas, Form1.Canvas.ClipRect);
  FusBitmap := TBitmap.Create;
  FusBitmap.Assign(FinalBitmap);
  FusBitmap.PixelFormat := pf32bit;
  tcol := GetRGB(Form1.TransparentColorValue);
  For Y := 0 To FusBitmap.Height - 1 Do Begin
    pd := FusBitmap.ScanLine[Y];
    pa := TmpBitmap.ScanLine[Y];
    For X := 0 To FusBitmap.Width - 1 Do Begin
      If (pa[X * 3 + 2] <> tcol.R) Or
         (pa[X * 3 + 1] <> tcol.G) Or
         (pa[X * 3 + 0] <> tcol.B) Then Begin
        pd[X * 4 + 0] := pa[X * 3 + 0];
        pd[X * 4 + 1] := pa[X * 3 + 1];
        pd[X * 4 + 2] := pa[X * 3 + 2];
        pd[X * 4 + 3] := $FF;
      End;
    End;
  End;
  TmpBitmap := Nil;

  // Applique la nouvelle image et cache les controls //
  FusionForm(AlphaForm, FusBitmap);
  FusBitmap := Nil;

  // Boucle de dplacement de la form  //
  Screen.Cursor := crSizeAll;
  X := ScreenToClient(Mouse.CursorPos).X;
  Y := ScreenToClient(Mouse.CursorPos).Y;
  Form1.Hide;
  Application.ProcessMessages;
  Repeat
    Left := Left + ScreenToClient(Mouse.CursorPos).X - X;
    Top := Top + ScreenToClient(Mouse.CursorPos).Y - Y;
  Until ((GetAsyncKeyState(VK_LBUTTON) And $8000) = 0);

  LockWindowUpdate(Form1.Handle);
  Form1.Left := Left;
  Form1.Top := Top;
  Application.ProcessMessages;
  Form1.Show;
  LockWindowUpdate(0);
  Screen.Cursor := crDefault;
End;


{----------------------------------------------------------------}
{ Exemple d'objet actif -> Bouton EXIT                           }
{----------------------------------------------------------------}
Procedure TForm1.Button1Click(Sender: TObject);
Begin
  Application.Terminate;
End;


{----------------------------------------------------------------}
End.



